unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ScrollBox1: TScrollBox;
    Image1: TImage;
    Panel1: TPanel;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses NanoJpeg;

{$POINTERMATH ON}

procedure TForm1.Button1Click(Sender: TObject);
var
  M : TMemoryStream;
  D : TNjDecoder;
  B : TBitmap;
  I,J : integer;
  P : PByte;
begin
  M := TMemoryStream.Create;
  try
    M.LoadFromFile( ExtractFilePath(Application.ExeName) + '\test.jpg' );
    M.Position := 0;

    D := TNjDecoder.Create;
    try
      if not D.Decode(M.Memory,M.Size) then
        Caption := 'Failed'
      else
      begin
        B := TBitmap.Create;
        B.PixelFormat := pf24bit;
        B.Width := D.GetWidth;
        B.Height := D.GetHeight;
        P := D.GetImage;
        for I := 0 to B.Height-1 do
          for J := 0 to B.Width - 1 do
            begin
              B.Canvas.Pixels[J,I] := RGB(P[0],P[1],P[2]);
              Inc(P,3);
            end;
        Image1.Picture.Assign(B);
        B.Free;
      end;
    finally
      D.Free;
    end;

  finally
    M.Free;
  end;
end;

end.
